/***************************************************************************
                          cmaprecord.cpp  -  description
                             -------------------
    begin                : Wed Jan 8 2003
    copyright            : (C) 2003 by Oleksiy Kohany
    email                : kohany@girinst.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <iomanip>
#include <sstream>
#include "incompletedata_exception.h"
#include "cmaprecord.h"

CMPBY CMapRecord::cmpby = TF;

CMapRecord::CMapRecord()
{}
CMapRecord::~CMapRecord()
{}
/** Read property of string TGT. */
const string& CMapRecord::getTGT()
{
    return TGT;
}
/** Write property of string TGT. */
void CMapRecord::setTGT( const string& _newVal)
{
    TGT = _newVal;
}
/** Read property of string QU. */
const string& CMapRecord::getQU()
{
    return QU;
}
/** Write property of string QU. */
void CMapRecord::setQU( const string& _newVal)
{
    QU = _newVal;
}
/** Read property of unsigned long TGTFrom. */
const unsigned long& CMapRecord::getTGTFrom()
{
    return TGTFrom;
}
/** Write property of unsigned long TGTFrom. */
void CMapRecord::setTGTFrom( const unsigned long& _newVal)
{
    TGTFrom = _newVal;
}
/** Read property of unsigned long TGTTo. */
const unsigned long& CMapRecord::getTGTTo()
{
    return TGTTo;
}
/** Write property of unsigned long TGTTo. */
void CMapRecord::setTGTTo( const unsigned long& _newVal)
{
    TGTTo = _newVal;
}
/** Read property of unsigned long QUFrom. */
const unsigned long& CMapRecord::getQUFrom()
{
    return QUFrom;
}
/** Write property of unsigned long QUFrom. */
void CMapRecord::setQUFrom( const unsigned long& _newVal)
{
    QUFrom = _newVal;
}
/** Read property of unsigned long QUTo. */
const unsigned long& CMapRecord::getQUTo()
{
    return QUTo;
}
/** Write property of unsigned long QUTo. */
void CMapRecord::setQUTo( const unsigned long& _newVal)
{
    QUTo = _newVal;
}
/** Read property of CMPBY cmpby. */
const CMPBY& CMapRecord::getcmpby()
{
    return CMapRecord::cmpby;
}
/** Write property of CMPBY cmpby. */
void CMapRecord::setcmpby( const CMPBY& _newVal)
{
    CMapRecord::cmpby = _newVal;
}
/** No descriptions */
bool CMapRecord::operator > (const CMapRecord& rc) const
{
    return getCmpVal() > rc.getCmpVal();
}
/** No descriptions */
bool CMapRecord::operator < (const CMapRecord& rc) const
{
    return getCmpVal() < rc.getCmpVal();
}
/** No descriptions */
bool CMapRecord::operator == (const CMapRecord& rc) const
{
    return getCmpVal() == rc.getCmpVal();
}
/** No descriptions */
unsigned long CMapRecord::getCmpVal() const
{
    switch(cmpby)
    {
    case TF:
        return TGTFrom;
        break;
    case TT:
        return TGTTo;
        break;
    case QF:
        return QUFrom;
        break;
    case QT:
        return QUTo;
        break;
    default:
        return TGTFrom;
        break;
    }
}
/** No descriptions */
CMapRecord::CMapRecord(const string& tg, unsigned long tf, unsigned long tt, const string& qu, unsigned long qf, unsigned long qt)
{
    assign(tg, tf, tt, qu, qf, qt);
}
/** No descriptions */
void CMapRecord::assign(const string& tg, unsigned long tf, unsigned long tt, const string& qu, unsigned long qf, unsigned long qt)
{
    setTGT(tg);
    setTGTFrom(tf);
    setTGTTo(tt);
    setQU(qu);
    setQUFrom(qf);
    setQUTo(qt);
}
/** No descriptions */
void CMapRecord::print(FILE *os) const
{
    fprintf(os, "%s\t%d\t%d\t%s\t%d\t%d\n", TGT.c_str(), TGTFrom, TGTTo, QU.c_str(), QUFrom, QUTo);
}
/** No descriptions */
void CMapRecord::print(ostream* os) const
{
    (*os) << TGT << "\t" << TGTFrom << "\t" << TGTTo << "\t"
    << QU << "\t" << QUFrom << "\t" << QUTo << "\n";
}
/** No descriptions */
int CMapRecord::read(FILE *is)
{
    char sLine[MAXLINELENGTH];
    char s1[MAXNAMESIZE];
    char s2[MAXNAMESIZE];
    TGTFrom = TGTTo = 0;
    QUFrom = QUTo = 0;
    int cnt = 0;
    while(fgets(sLine, MAXLINELENGTH, is))
    {
        cnt = sscanf(sLine, "%s%d%d%s%d%d", s1, &TGTFrom, &TGTTo, s2, &QUFrom, &QUTo);
        if(cnt >= 3)
        {
            TGT = s1;
            if(cnt == 6)
            {
                QU = s2;
            }
            break;
        }
        else {
            cerr << "WARNING: Invalid map line:" << sLine;
        }
    }
    return int(cnt/3);
}
/** No descriptions */
int CMapRecord::read(istream* is)
{
    string s;
    TGTFrom = TGTTo = 0;
    QUFrom = QUTo = 0;
    getline(*is, s);
    istringstream iss;
    iss.str(s);
    iss >> TGT >> TGTFrom >> TGTTo;
    if(iss.fail())
    {
        return 0;
    }
    iss >> QU >> QUFrom >> QUTo;
    if(iss.fail())
    {
        return 1;
    }
    return 2;
}

istream& operator >> (istream& is, CMapRecord& mr)
{
    mr.read(&is);
    return is;
}

ostream& operator << (ostream& os, CMapRecord& mr)
{
    mr.print(&os);
    return os;
}
