#include "functions.h"
#include "seqdb.h"
#include <stdio.h>
#include <map>
#include <string>
#include <string.h>

using namespace std;

//-------------------------------------------
  void CLocusPos::assign(const char *pcFName, const long iCom, const long iPos) {
    if(m_pcFName != NULL) {
      delete [] m_pcFName;
    }
    m_pcFName = new char[strlen(pcFName) + 1];
    strcpy(m_pcFName, pcFName);
    m_iCom = iCom;
    m_iPos = iPos;
  }
//-------------------------------------------
  CLocusPos& CLocusPos::operator = (const CLocusPos &Pos) {
    assign(Pos.m_pcFName, Pos.m_iCom, Pos.m_iPos);
    return *this;
  }
//-------------------------------------------
  long CLocusPos::getPos() const {
    if(SHOWCOMMENT) {
      return m_iCom;
    }
    else {
      return m_iPos;
    }
  }

bool CLocusPos::SHOWCOMMENT = true;
char CLocusPos::ssPath[MAXNAMESIZE] = ".";
//===========================================
FILE* CSdb::findLocus_File(FILE *INF, const char *pcFName, const char *pLName, POSMAP &pmap) {
  POSMAP::iterator mptr;
  char sLine[MAXLINELENGTH];
  char sName[MAXNAMESIZE];
  char *pRes;
  static CLocusPos Res;
  static FILE *F;
  static long isPos, isCom;
  Res.assign("\0", -1, -1);
  if((mptr = pmap.find(pLName)) != pmap.end()) {
    fseek(INF, (*mptr).second.getPos(), SEEK_SET);
    return INF;
  }
  if(strrchr(pcFName, '/') != NULL) {
    pcFName = strrchr(pcFName, '/') + 1;
  }
  if(INF == F) {
    fseek(INF, isPos, SEEK_SET);
  }
  else {
    rewind(INF);
    F = INF;
  }
  sLine[0] = '\0';
  while(sLine[0] == ';' || sLine[0] == '>' || (pRes = fgets(sLine, MAXLINELENGTH, INF)) != NULL) {
    switch(sLine[0]) {
    case ';':
      while((pRes = fgets(sLine, MAXLINELENGTH, INF)) != NULL && sLine[0] == ';');
      if(pRes == NULL) {
	return NULL;
      }
      sscanf(sLine, "%s", sName);
      break;
    case '>':
      sscanf(sLine + 1, "%s", sName);
      break;
    default:
      isCom = ftell(INF);
      continue;
    }
    isPos = ftell(INF);
    if(pmap.find(sName) == pmap.end()) {
      pmap[sName].assign(pcFName, isCom, isPos);
    }
    isCom = ftell(INF);
    if(strcmp(sName, pLName) == 0) {
      fseek(INF, pmap[sName].getPos(), SEEK_SET);
      return INF;
    }
    while(((pRes = fgets(sLine, MAXLINELENGTH, INF)) != NULL) && (*sLine != ';') && (*sLine != '>')) {
      isCom = ftell(INF);
    }
    if(pRes == NULL) {
      break;
    }
  }
  isPos = ftell(INF);
  return NULL;
}
//-------------------------------------------
FILE* CSdb::findLocus_Map(const char *pLName, const POSMAP &pmap) {
  POSMAP::const_iterator mptr;
  static FILE *F;
  static char sFName[MAXNAMESIZE];
  static char sPath[MAXNAMESIZE];
  if((mptr = pmap.find(pLName)) != pmap.end()) {
    if(strcmp(sFName, (*mptr).second.m_pcFName) == 0 && F != NULL) {
      fseek(F, (*mptr).second.getPos(), SEEK_SET);
      return F;
    }
    if(F != NULL) {
      fclose(F);
      F = NULL;
      sFName[0] = '\0';
    }
    strcpy(sPath, CLocusPos::ssPath);
    strcat(sPath, "/");
    strcat(sPath, (*mptr).second.m_pcFName);
#ifdef DEBUG
    fprintf(stderr, "Opening %s\n", sPath);
#endif
    if((F = fopen(sPath, "r")) != NULL) {
      fseek(F, (*mptr).second.getPos(), SEEK_SET);
      strcpy(sFName, (*mptr).second.m_pcFName);
      return F;
    }
    else {
      fprintf(stderr, "Failed to open %s for reading\n", sPath);
    }
  }
  return NULL;
}
//-------------------------------------------
FILE* CSdb::getLocus(const char *pLName) {
  if(m_pFDB == NULL) {
    return findLocus_Map(pLName, m_pmap);
  }
  else {
    return findLocus_File(m_pFDB, m_sDBName, pLName, m_pmap);
  }
}
//-------------------------------------------
  int CSdb::loadIndex(FILE *F, POSMAP &pmap) {
    char line[MAXLINELENGTH];
    char sLName[MAXNAMESIZE];
    char sFName[MAXNAMESIZE];
    long nCom = 0, nFrom = 0;
    int linecount = 0, datacount = 0;
    while(fgets(line, MAXLINELENGTH, F) != NULL) {
      linecount++;
      if(isEmpty(line)) {
         continue;
      }
      if(sscanf(line, "%s%s%ld%ld", sFName, sLName, &nCom, &nFrom) < 4) {
         return -1;
      }
      pmap[sLName].assign(sFName, nCom, nFrom);
      datacount++;
    }
    return datacount;
  }
//-------------------------------------------
  void CSdb::saveIndex(FILE *F, const POSMAP &pmap) {
    POSMAP::const_iterator mptr;
    for(mptr = pmap.begin(); mptr != pmap.end(); mptr++) {
      fprintf(F, "%s\t%s\t%ld\t%ld\n", (*mptr).second.m_pcFName, (*mptr).first.c_str(), (*mptr).second.m_iCom, (*mptr).second.m_iPos);
    }
  }
